#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;

#define INF (1ll<<61)
struct Edge{ ll t, w; };
typedef vector<vector<Edge>> graph;
struct Res{ ll back, len; };
struct El{ ll id, w; bool operator<(const El&e)const{ return w!=e.w?w>e.w:id<e.id; } };

// graph of nodes with pair (neighbour, weight)
vector<Res> dijkstra(graph& g, ll start) {
    ll N = g.size();
    vector<Res> res(N, {-1, INF}); // previous, cost
    res[start].back = start;
    res[start].len = 0;
    vector<bool> todo(N, 1);
    // edge weight, target
    priority_queue<El> q;
    q.push({start,0});
    while (!q.empty()) {
        El el = q.top(); q.pop();
        ll basew = el.w;
        ll id = el.id;
        // if (id == end) break; // add parameter if end known
        if (todo[id]) {
            todo[id] = 0;
            for (auto e : g[id]) {
                ll v = e.t;
                ll ne = basew + e.w;
                if (ne < res[v].len) {
                    res[v].back = id;
                    res[v].len = ne;
                    q.push({v,ne});
                }
            }
        }
    }
    return res;
}

ll solve(graph g, vector<ll> &v){
    ll N = g.size();
    ll start = g.size(); g.push_back(vector<Edge>());
    ll end   = g.size(); g.push_back(vector<Edge>());
    for(ll i=0; i<N; ++i){
        ll connection = start+(rand()%2);
        g[i].push_back({connection, v[i]});
        g[connection].push_back({i, v[i]});
    }
    auto res = dijkstra(g, start);
    return res[end].len;
}

int main(){
    srand(time(NULL));
    ll res = INF;
    ll N, M;
    cin >> N >> M;
    vector<ll> v(N);for(ll &n:v)cin>>n;
    graph g(N);
    for(ll i=0; i<M; ++i){
        ll f, t, w;
        cin >> f >> t >> w;
        g[f].push_back({t, w});
        g[t].push_back({f, w});
    }
    for(ll i=0; i<40; ++i) res = min(res, solve(g, v));
    cout << res << endl;
    return 0;
}
